declare
proc {AddAux X Y Z SizeX SizeY SizeZ}
   if {Wait {FD.watch.size X SizeX}} then skip
   [] {Wait {FD.watch.size Y SizeY}} then skip
   [] {Wait {FD.watch.size Z SizeZ}} then skip
   end
   BagX={Dictionary.new}
   BagY={Dictionary.new}
   BagZ={Dictionary.new}
   DomX={FD.reflect.domList X}
   DomY={FD.reflect.domList Y}
   DomZ={FD.reflect.domList Z}
in
   {ForAll DomX
    proc {$ DX}
       {ForAll DomY
	proc {$ DY}
	   case {Member DX+DY DomZ}
	   then
	      {Dictionary.put BagX DX _}
	      {Dictionary.put BagY DY _}
	      {Dictionary.put BagZ DX+DY _}
	   else skip
	   end
	end}
    end}
   X::{Dictionary.keys BagX}
   Y::{Dictionary.keys BagY}
   Z::{Dictionary.keys BagZ}
   {AddAux X Y Z
    {FD.reflect.size X}
    {FD.reflect.size Y}
    {FD.reflect.size Z}}
end

proc {AddProp X Y Z}
   {AddAux X Y Z FD.sup FD.sup FD.sup}
end
