declare
Data =
adjacency(austria    : [ germany
			 italy
			 switzerland]
	  belgium    : [france
			germany
			luxembourg
			netherlands]
	  france     : [ italy
			 germany
			 luxembourg
			 spain]
	  germany    : [luxembourg
			netherlands]
	  italy      : [switzerland]
	  luxembourg : nil
	  netherlands: nil
	  portugal   : [spain]
	  spain      : nil
	  switzerland: nil
	 )

declare
fun {MapColoring Data}
   proc {$ Root}
      NbColors#Color=Root
   in
      NbColors = {FD.decl}
      
      % distribute number of colors
      {FD.distribute naive [NbColors]}
      {FD.record color {Arity Data}
       1#NbColors Color}
      {Record.forAllInd Data
       proc {$ A Bs}
	  {ForAll Bs
	   proc {$ B} Color.A \=: Color.B end}
       end}
      
      % distribute colors
      {FD.distribute ff Color}
   end
end

{ExploreOne {MapColoring Data}}

