declare
\insert constants
\insert tkaux
MoneyFont="-*-Courier New-normal-r-r*-*-200-180-*-*-c-*-*-ansi-"
local
fun {ML Root L}
   Dom={FD.reflect.dom Root.L}
   Desc={FoldL Dom fun {$ Acc X}
		      Acc # ' ' #
		      case X of Low#High then Low#'..'#High
		      else X end
		   end '{'}
in
   label(text:L#Desc#' } '
	 font:MoneyFont)
end
fun {TL L}
   label(text:L font:MoneyFont)
end
in
   proc {ShowMoney R}
      {Show R#Grid}
   MoneyWindow={New Tk.toplevel tkInit(title:'MONEY')}
in
   row(                        3:{ML R s} 4:{ML R e} 5:{ML R n} 6:{ML R d})
   #
   row(           2:{TL '+'}   3:{ML R m} 4:{ML R o} 5:{ML R r} 6:{ML R e})
   #
   row(1:{TL '='} 2:{ML R m}   3:{ML R o} 4:{ML R n} 5:{ML R e} 6:{ML R y})
   ={Grid MoneyWindow}
   end

   proc {ShowMostMoney R}
      MoneyWindow={New Tk.toplevel tkInit(title:'MONEY')}
   in
      row(                        3:{ML R s} 4:{ML R e} 5:{ML R n} 6:{ML R d})
      #
      row(           2:{TL '+'}   3:{ML R m} 4:{ML R o} 5:{ML R s} 6:{ML R t})
      #
      row(1:{TL '='} 2:{ML R m}   3:{ML R o} 4:{ML R n} 5:{ML R e} 6:{ML R y})
      ={Grid MoneyWindow}
   end
end
